pub trait Waveform {
    fn x(&self, t: f64) -> f32;
}

#[derive(Default, Debug)]
pub struct Saw;
#[derive(Default, Debug)]
pub struct Square;

impl Waveform for Saw {
    fn x(&self, t: f64) -> f32 {
        ((t % 1.0) * 2.0 - 1.0) as f32
    }
}

impl Waveform for Square {
    fn x(&self, t: f64) -> f32 {
        if t % 1.0 < 0.5 {
            -1.0
        } else {
            1.0
        }
    }
}
